#include <stdio.h>   /* Standard input/output definitions */
#include <string.h>  /* String function definitions */
#include <unistd.h>  /* UNIX standard function definitions */
#include <fcntl.h>   /* File control definitions */
#include <errno.h>   /* Error number definitions */
#include <termios.h> /* POSIX terminal control definitions */
#include <getopt.h>  /* Getopt definitions */
#include <stdlib.h>  /* Standard library definitions */
#include <assert.h>  /* Assert library definitions */
#include <time.h>

// misc macros
#define AZ(foo) do { assert((foo) == 0); } while (0)

static char * weekdays[] = {
  "søndag",
  "mandag",
  "tirsdag",
  "onsdag",
  "torsdag",
  "fredag",
  "lørdag"
};

static char * months[] = {
  "januar",
  "februar",
  "marts",
  "april",
  "maj",
  "juni",
  "juli",
  "august",
  "september",
  "oktober",
  "november",
  "december"
};

void print_time() {

  time_t s =  time(NULL);
  struct tm ct;
  localtime_r(&s, &ct);

  printf("Er det\n %s d. %d. %s %04d\n                              i dag?\n", weekdays[ct.tm_wday], ct.tm_mday, months[ct.tm_mon], 1900 + ct.tm_year);
}

void set_time() {
  struct tm nt;
  nt.tm_sec = 0;
  nt.tm_min = 35;
  nt.tm_hour = 22;
  nt.tm_mday = 15;
  nt.tm_mon = 10;
  nt.tm_year = 107;
  nt.tm_isdst = 0;

  struct timeval tv;
  tv.tv_sec = mktime(&nt);
  tv.tv_usec = 0;
  
  printf("Setting the clock to %d of epoch\n", tv.tv_sec); 

  int ret = settimeofday(&tv, NULL);
  if (ret == -1) {
    perror("settimeofday");
  }
  
}

int main(int argc, char * const argv[])
{
  print_time();
  set_time();
}
