#include <stdio.h>   /* Standard input/output definitions */
#include <string.h>  /* String function definitions */
#include <unistd.h>  /* UNIX standard function definitions */
#include <fcntl.h>   /* File control definitions */
#include <errno.h>   /* Error number definitions */
#include <termios.h> /* POSIX terminal control definitions */
#include <getopt.h>  /* Getopt definitions */
#include <stdlib.h>  /* Standard library definitions */
#include <assert.h>  /* Assert library definitions */
#include <sys/types.h>
#include <sys/time.h>
#include <time.h>
#include <sys/select.h>
#include <readline/readline.h>
#include <readline/history.h>

#define UNCH unsigned char

// misc macros
#define AZ(foo) do { assert((foo) == 0); } while (0)

/* socket to emulate the serial port on */
#define DEFAULT_SOCKET "/tmp/nad_t763.sock"
char * socket;

/* emulated model */
#define DEFAULT_MODEL "T763"
char * model;

// FD_TYPE_CONSTANTS
#define FD_TYPE_RS232 0
#define FD_TYPE_SOCKET 1
#define FD_TYPE_CONN 2

// fd information struct
typedef struct {
  UNCH type; // FD_TYPE_CONSTANTS
  int fd;
} fdinfo;

fdinfo nad_fdi; /* File descriptor for the serial port */

int main(int argc, char * const argv[]);

