#include <stdio.h>   /* Standard input/output definitions */
#include <string.h>  /* String function definitions */
#include <unistd.h>  /* UNIX standard function definitions */
#include <fcntl.h>   /* File control definitions */
#include <errno.h>   /* Error number definitions */
#include <termios.h> /* POSIX terminal control definitions */
#include <getopt.h>  /* Getopt definitions */
#include <stdlib.h>  /* Standard library definitions */
#include <assert.h>  /* Assert library definitions */
#include <sys/types.h>
#include <sys/time.h>
#include <sys/select.h>
#include <time.h>

// request cmds
#define CMD_REQ_MODEL      "\x02\x14\x14"
#define CMD_REQ_VOL        "\x02\x14\x17"
#define CMD_REQ_VOL_UP     "\x02\x16\x88"
#define CMD_REQ_VOL_DOWN   "\x02\x16\x8C"
#define CMD_REQ_ALL        "\x02\x14\xFF"
#define CMD_REQ_GET_TIME   "\x02\x4C\x20"
#define CMD_REQ_SET_TIME   "\x02\x4C\x21"

// response cmds
#define CMD_RESP_VOL_CHANGE "\x02\x14\x17"
#define CMD_RESP_MODEL_INFO "\x02\x14\x14"
#define CMD_RESP_SPEAKER_A  "\x02\x14\x3A"
#define CMD_RESP_SPEAKER_B  "\x02\x14\x3B"

// argument list for response handlers
#define HANDLER_ARGS fdinfo * fdi, char * data

void model_message(HANDLER_ARGS);
void vol_message(HANDLER_ARGS);
void speaker_message(HANDLER_ARGS);
void get_time_message(HANDLER_ARGS);
void set_time_message(HANDLER_ARGS);

// define handlers
extern struct message_handler {
  char * trigger;
  void (*handler) (HANDLER_ARGS);
} handlers[];


