#include <stdio.h>   /* Standard input/output definitions */
#include <string.h>  /* String function definitions */
#include <unistd.h>  /* UNIX standard function definitions */
#include <fcntl.h>   /* File control definitions */
#include <errno.h>   /* Error number definitions */
#include <termios.h> /* POSIX terminal control definitions */
#include <getopt.h>  /* Getopt definitions */
#include <stdlib.h>  /* Standard library definitions */
#include <assert.h>  /* Assert library definitions */
#include <sys/types.h>
#include <sys/time.h>
#include <sys/select.h>
#include <time.h>

#define DEFAULT_PORT "/dev/ttyS0"
#define DEFAULT_LIMIT -20
#define BAUDRATE B9600

#define UNCH unsigned char

// misc macros
#define AZ(foo) do { assert((foo) == 0); } while (0)

/* Serial port */
char * port;

// FD_TYPE_CONSTANTS
#define FD_TYPE_RS232 0
#define FD_TYPE_CONN 1

// fd information struct
typedef struct {
  UNCH type; // FD_TYPE_CONSTANTS
  int fd;
} fdinfo;

fdinfo nad_fdi; /* File descriptor for the serial port */

/* Used to store `--limit'. */
signed char limit;
signed char speakers[2];

void idleloop();
int main(int argc, char * const argv[]);

